# lab4实验报告

## Thinking 4.1

> Thinking 4.1 思考并回答下面的问题：
>
> • 内核在保存现场的时候是如何避免破坏通用寄存器的？
>
> • 系统陷入内核调用后可以直接从当时的$a0-$a3参数寄存器中得到用户调用msyscall
>
> 留下的信息吗？
>
> • 我们是怎么做到让sys 开头的函数“认为”我们提供了和用户调用msyscall 时同样
>
> 的参数的？
>
> • 内核处理系统调用的过程对Trapframe 做了哪些更改？这种修改对应的用户态的变
>
> 化是什么？

* 通用寄存器被储存到栈帧相关的数组中：`Trapframe.regs[]`，同时`sp`，`v0`两个寄存器由于在保存过程中需要使用，被优先保存
* 可以
* 用户调用的参数`a1-a5`被保存在栈帧中，在调用系统调用函数之前，这些参数被从栈帧中取出保存到内核栈中
* `epc`被加4，保证返回用户程序时，cpu会执行系统调用的后一条指令；返回值被保存到`v0`

## Thinking 4.2

> Thinking 4.2 思考 envid2env函数: 为什么 envid2env中需要判断 e->env_id != envid
>
> 的情况？如果没有这步判断会发生什么情况？

按照偏移取出的`env`可能是已经被销毁的进程块，所以需要再次检查

## Thinking 4.3

> Thinking 4.3 思考下面的问题，并对这个问题谈谈你的理解：请回顾kern/env.c 文件
>
> 中mkenvid() 函数的实现，该函数不会返回0，请结合系统调用和IPC 部分的实现与
>
> envid2env() 函数的行为进行解释。

在`envid2env`中，如果`envid`为0会直接获取`curenv`，由于当前进程块在用户态是不可见的，这样规定可以更方便的获取到当前进程块。在`mkenvid`中，返回值保证不会为0，从而保证`envid2env`能获取到正确的进程块

## Thinking 4.4

> Thinking 4.4 关于fork 函数的两个返回值，下面说法正确的是：
>
> A、fork 在父进程中被调用两次，产生两个返回值
>
> B、fork 在两个进程中分别被调用一次，产生两个不同的返回值
>
> C、fork 只在父进程中被调用了一次，在两个进程中各产生一个返回值
>
> D、fork 只在子进程中被调用了一次，在两个进程中各产生一个返回值

C

## Thinking 4.5

> Thinking 4.5 我们并不应该对所有的用户空间页都使用 duppage 进行映射。那么究竟哪
>
> 些用户空间页应该映射，哪些不应该呢？请结合 kern/env.c 中env_init 函数进行的页
>
> 面映射、include/mmu.h 里的内存布局图以及本章的后续描述进行思考。

0～`USTACKTOP`之间的空间为用户空间，需要映射，其他内存空间都不需要

## Thinking 4.6

> Thinking 4.6 在遍历地址空间存取页表项时你需要使用到 vpd 和 vpt 这两个指针，请参
>
> 考user/include/lib.h 中的相关定义，思考并回答这几个问题：
>
> • vpt 和 vpd 的作用是什么？怎样使用它们？
>
> • 从实现的角度谈一下为什么进程能够通过这种方式来存取自身的页表？
>
> • 它们是如何体现自映射设计的？
>
> • 进程能够通过这种方式来修改自己的页表项吗？

* `vpt`，`vpd`用于在用户空间访问自己地址空间的页表

* `vpt`是用户页表首地址，`vpd`是用户页目录首地址，这两个地址都是通过页表自映射得到的

* 从这两个变量的定义可以看出自映射在此处的应用

  ```
  #define vpt ((const volatile Pte *)UVPT)
  #define vpd ((const volatile Pde *)(UVPT + (PDX(UVPT) << PGSHIFT)))
  ```

* 不能，这个部分的页表只能读不能写

## Thinking 4.7

> Thinking 4.7 在do_tlb_mod 函数中，你可能注意到了一个向异常处理栈复制 Trapframe
>
> 运行现场的过程，请思考并回答这几个问题：
>
> • 这里实现了一个支持类似于“异常重入”的机制，而在什么时候会出现这种“异常重
>
> 入”？
>
> • 内核为什么需要将异常的现场 Trapframe 复制到用户空间？

* 产生COW异常时会出现
* 内核退出中断时会回到用户态异常处理函数，之后仍然需要在用户态恢复现场

## Thinking 4.8

> Thinking 4.8 在用户态处理页写入异常，相比于在内核态处理有什么优势？

* 减少进入内核态产生的开销
* 用户态能进行的内存操作更少，相对更安全
* 产生错误不会导致操作系统崩溃

## Thinking 4.9

> Thinking 4.9 请思考并回答以下几个问题：
>
> • 为什么需要将 syscall_set_tlb_mod_entry的调用放置在 syscall_exofork之前？
>
> • 如果放置在写时复制保护机制完成之后会有怎样的效果？

* `syscall_exofork()`会涉及到COW中断，COW中断的处理依赖于`syscall_set_tlb_mod_entry`，所以需要先将其设置好
* 写时复制保护机制可能产生缺页异常，如果没有设置好会导致异常处理产生问题



